(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('guid-typescript'), require('lodash')) :
    typeof define === 'function' && define.amd ? define('@seers/lineage', ['exports', 'guid-typescript', 'lodash'], factory) :
    (global = global || self, factory((global.seers = global.seers || {}, global.seers.lineage = {}), global.guidTypescript, global.lodash));
}(this, (function (exports, guidTypescript, lodash) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var FlowMode = {
        None: "",
        ProRata: "ProRata",
        FirstInFirstOut: "FirstInFirstOut",
        LastInFirstOut: "LastInFirstOut",
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var BatchType = {
        Source: "Source",
        Target: "Target",
        Adjustment: "Adjustment",
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var AdjustmentMode = {
        Absolute: "Absolute",
        Relative: "Relative",
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function Criteria() { }
    ;
    /**
     * @record
     */
    function IBatch() { }
    if (false) {
        /** @type {?|undefined} */
        IBatch.prototype.id;
        /** @type {?|undefined} */
        IBatch.prototype.name;
        /** @type {?} */
        IBatch.prototype.time;
        /** @type {?} */
        IBatch.prototype.type;
        /** @type {?|undefined} */
        IBatch.prototype.criteria;
        /** @type {?|undefined} */
        IBatch.prototype.quantity;
        /** @type {?|undefined} */
        IBatch.prototype.attributes;
        /** @type {?|undefined} */
        IBatch.prototype.measures;
        /** @type {?|undefined} */
        IBatch.prototype.flowMode;
    }
    var Batch = /** @class */ (function () {
        function Batch(batch) {
            var _this = this;
            if (batch === void 0) { batch = null; }
            this.id = guidTypescript.Guid.create().toString();
            this.criteria = {};
            this.attributes = {};
            this.flowMode = FlowMode.ProRata;
            this.adjustmentMode = AdjustmentMode.Absolute;
            this.flowsIn = [];
            this.flowsOut = [];
            /**
             * returns the balance of the batch
             */
            this.balanceAtTime = (/**
             * @param {?=} time
             * @return {?}
             */
            function (time) {
                //  Check whether the time is before the time of this batch
                if (time < _this.time)
                    return null;
                /** @type {?} */
                var balance = 0;
                //  Source batches have an intrinsic quantity that does not come from FlowsIn
                if (_this.type == BatchType.Source)
                    balance += _this.quantity;
                balance = balance
                    + lodash.sumBy(_this.flowsIn, (/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) { return x.quantity; }))
                    - lodash.sumBy(lodash.filter(_this.flowsOut, (/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) { return x.target.time <= time; })), (/**
                     * @param {?} x
                     * @return {?}
                     */
                    function (x) { return x.quantity; }));
                return balance;
            });
            this.balancesOverTime = (/**
             * @param {?} times
             * @return {?}
             */
            function (times) {
                /** @type {?} */
                var balances = [];
                lodash.each(times, (/**
                 * @param {?} t
                 * @return {?}
                 */
                function (t) {
                    balances.push(_this.balanceAtTime(t));
                }));
                return balances;
            });
            //  Returns the calculated attributes of this batch at the given time
            this.attributesAtTime = (/**
             * @param {?=} time
             * @return {?}
             */
            function (time) {
                //  Check whether the time is valid
                if (time < _this.time)
                    return null;
                //  Start with the target attributes of this batch
                return _this.attributes;
            });
            this.attributesOverTime = (/**
             * @param {?} times
             * @return {?}
             */
            function (times) {
                /** @type {?} */
                var attributes = [];
                lodash.each(times, (/**
                 * @param {?} t
                 * @return {?}
                 */
                function (t) {
                    attributes.push(_this.attributesAtTime(t));
                }));
                return attributes;
            });
            Object.assign(this, batch);
        }
        Object.defineProperty(Batch.prototype, "time", {
            get: /**
             * @return {?}
             */
            function () {
                return this._time;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value instanceof Date) {
                    this._time = value;
                }
                else {
                    this._time = new Date(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        return Batch;
    }());
    if (false) {
        /** @type {?} */
        Batch.prototype.type;
        /** @type {?} */
        Batch.prototype.id;
        /** @type {?} */
        Batch.prototype.name;
        /**
         * @type {?}
         * @private
         */
        Batch.prototype._time;
        /** @type {?} */
        Batch.prototype.criteria;
        /** @type {?} */
        Batch.prototype.quantity;
        /** @type {?} */
        Batch.prototype.attributes;
        /** @type {?} */
        Batch.prototype.measures;
        /** @type {?} */
        Batch.prototype.flowMode;
        /** @type {?} */
        Batch.prototype.adjustmentMode;
        /** @type {?} */
        Batch.prototype.flowsIn;
        /** @type {?} */
        Batch.prototype.flowsOut;
        /**
         * returns the balance of the batch
         * @type {?}
         */
        Batch.prototype.balanceAtTime;
        /** @type {?} */
        Batch.prototype.balancesOverTime;
        /** @type {?} */
        Batch.prototype.attributesAtTime;
        /** @type {?} */
        Batch.prototype.attributesOverTime;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Flow = /** @class */ (function () {
        function Flow() {
        }
        return Flow;
    }());
    if (false) {
        /** @type {?} */
        Flow.prototype.source;
        /** @type {?} */
        Flow.prototype.target;
        /** @type {?} */
        Flow.prototype.time;
        /** @type {?} */
        Flow.prototype.quantity;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Lineage = /** @class */ (function () {
        function Lineage() {
            var _this = this;
            this.batches = [];
            this.flows = [];
            this.add = (/**
             * @param {?} batch
             * @return {?}
             */
            function (batch) {
                //  Convert to a Batch object if required
                if (batch instanceof Batch) {
                    _this.batches.push(batch);
                    return batch;
                }
                else {
                    return _this.add(new Batch(batch));
                }
            });
            this.createFlow = (/**
             * @param {?} source
             * @param {?} target
             * @param {?} time
             * @param {?} quantity
             * @return {?}
             */
            function (source, target, time, quantity) {
                /** @type {?} */
                var flow = new Flow();
                flow.source = source;
                flow.target = target;
                flow.time = time;
                flow.quantity = quantity;
                source.flowsOut.push(flow);
                target.flowsIn.push(flow);
                _this.flows.push(flow);
            });
        }
        /**
         * @return {?}
         */
        Lineage.prototype.process = /**
         * @return {?}
         */
        function () {
            var _this = this;
            //  Clear out current flows
            lodash.each(this.batches, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                x.flowsIn.length = 0;
                x.flowsOut.length = 0;
            }));
            this.flows.length = 0;
            //  Filter out the batches that do not need processing (ie. the Sources)
            /** @type {?} */
            var batchesToProcess = lodash.filter(this.batches, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.type === BatchType.Target || x.type === BatchType.Adjustment; }));
            //  Order by Time
            batchesToProcess = lodash.sortBy(batchesToProcess, (/**
             * @param {?} batch
             * @return {?}
             */
            function (batch) { return batch.time; }));
            //  Process each batch
            lodash.each(batchesToProcess, (/**
             * @param {?} target
             * @return {?}
             */
            function (target) {
                //  Determine the type of target and process accordingly
                if (target.type === BatchType.Adjustment) {
                    _this.processAdjustment(target);
                }
                else if (target.type === BatchType.Target) {
                    //  Find candidate source batches
                    /** @type {?} */
                    var candidates = _this.findCandidates(target);
                    //  Process the batch
                    switch (target.flowMode) {
                        case FlowMode.ProRata:
                            _this.processProRata(target, candidates);
                            break;
                        case FlowMode.FirstInFirstOut:
                            _this.processFirstInFirstOut(target, candidates);
                            break;
                        case FlowMode.LastInFirstOut:
                            _this.processLastInFirstOut(target, candidates);
                            break;
                    }
                }
            }));
        };
        /**
         * @param {?} adjustment
         * @return {?}
         */
        Lineage.prototype.processAdjustment = /**
         * @param {?} adjustment
         * @return {?}
         */
        function (adjustment) {
            //  Process Adjustment according to the AdjustmentMode
            if (adjustment.adjustmentMode == AdjustmentMode.Absolute) {
                this.processAbsoluteAdjustment(adjustment);
            }
        };
        /**
         * @param {?} adjustment
         * @return {?}
         */
        Lineage.prototype.processAbsoluteAdjustment = /**
         * @param {?} adjustment
         * @return {?}
         */
        function (adjustment) {
            //  Find the source batches to adjust
            /** @type {?} */
            var candidates = this.findCandidates(adjustment);
            //  Find the total quantity of all the candidates
            /** @type {?} */
            var totalQuantity = lodash.sumBy(candidates, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.balanceAtTime(adjustment.time); }));
            //  Determine the relative adjustment, and negate it as we are flowing OUT of the sources rather than in
            /** @type {?} */
            var relativeAdjustment = -1 * (adjustment.quantity - totalQuantity);
            //  Create the flows
            this.createFlowsProRata(candidates, adjustment, relativeAdjustment);
        };
        /**
         * @param {?} sources
         * @param {?} target
         * @param {?} totalFlowQuantity
         * @return {?}
         */
        Lineage.prototype.createFlowsProRata = /**
         * @param {?} sources
         * @param {?} target
         * @param {?} totalFlowQuantity
         * @return {?}
         */
        function (sources, target, totalFlowQuantity) {
            var _this = this;
            //  Calculate the existing total quantity available from matching candidates
            /** @type {?} */
            var totalSourcesQuantity = lodash.sumBy(sources, (/**
             * @param {?} c
             * @return {?}
             */
            function (c) { return c.balanceAtTime(target.time); }));
            //  Add flow for each candidate
            lodash.each(sources, (/**
             * @param {?} source
             * @return {?}
             */
            function (source) {
                /** @type {?} */
                var sourceRemainingQuantity = source.balanceAtTime(target.time);
                /** @type {?} */
                var flowQuantity = lodash.min([sourceRemainingQuantity, (sourceRemainingQuantity / totalSourcesQuantity) * totalFlowQuantity]);
                _this.createFlow(source, target, target.time, flowQuantity);
            }));
        };
        /**
         * @param {?} target
         * @param {?} candidates
         * @return {?}
         */
        Lineage.prototype.processProRata = /**
         * @param {?} target
         * @param {?} candidates
         * @return {?}
         */
        function (target, candidates) {
            var _this = this;
            //  Calculate the total quantity available from matching candidates
            /** @type {?} */
            var totalAvailable = lodash.sumBy(candidates, (/**
             * @param {?} c
             * @return {?}
             */
            function (c) { return c.balanceAtTime(target.time); }));
            //  Add flow for each candidate
            lodash.each(candidates, (/**
             * @param {?} source
             * @return {?}
             */
            function (source) {
                /** @type {?} */
                var sourceRemainingQuantity = source.balanceAtTime(target.time);
                /** @type {?} */
                var flowQuantity = lodash.min([sourceRemainingQuantity, (sourceRemainingQuantity / totalAvailable) * target.quantity]);
                _this.createFlow(source, target, target.time, flowQuantity);
            }));
        };
        /**
         * @param {?} target
         * @param {?} candidates
         * @return {?}
         */
        Lineage.prototype.processLastInFirstOut = /**
         * @param {?} target
         * @param {?} candidates
         * @return {?}
         */
        function (target, candidates) {
            var _this = this;
            //  Sort the candidates by time, descending
            candidates = lodash.orderBy(candidates, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.time; }), 'desc');
            /** @type {?} */
            var targetQuantity = target.quantity;
            //  Loop through the sources and create flows until the target is fulfilled or the sources are exhausted
            lodash.each(candidates, (/**
             * @param {?} source
             * @return {?}
             */
            function (source) {
                /** @type {?} */
                var sourceQuantity = source.balanceAtTime(target.time);
                /** @type {?} */
                var flowQuantity = lodash.min([targetQuantity, sourceQuantity]);
                _this.createFlow(source, target, target.time, flowQuantity);
                targetQuantity -= flowQuantity;
                if (targetQuantity == 0) {
                    return false;
                }
            }));
        };
        /**
         * @param {?} target
         * @param {?} candidates
         * @return {?}
         */
        Lineage.prototype.processFirstInFirstOut = /**
         * @param {?} target
         * @param {?} candidates
         * @return {?}
         */
        function (target, candidates) {
            var _this = this;
            //  Sort the candidates by time, descending
            candidates = lodash.orderBy(candidates, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.time; }), 'asc');
            /** @type {?} */
            var targetQuantity = target.quantity;
            //  Loop through the sources and create flows until the target is fulfilled or the sources are exhausted
            lodash.each(candidates, (/**
             * @param {?} source
             * @return {?}
             */
            function (source) {
                /** @type {?} */
                var sourceQuantity = source.balanceAtTime(target.time);
                /** @type {?} */
                var flowQuantity = lodash.min([targetQuantity, sourceQuantity]);
                _this.createFlow(source, target, target.time, flowQuantity);
                targetQuantity -= flowQuantity;
                if (targetQuantity == 0) {
                    return false;
                }
            }));
        };
        /** returns a set of batches which could potentially fulfil a target batch */
        /**
         * returns a set of batches which could potentially fulfil a target batch
         * @param {?} target
         * @return {?}
         */
        Lineage.prototype.findCandidates = /**
         * returns a set of batches which could potentially fulfil a target batch
         * @param {?} target
         * @return {?}
         */
        function (target) {
            var _this = this;
            /** @type {?} */
            var candidates = this.batches;
            //  Eliminate the target from the candidates (a batch cannot fulfil itself)
            candidates = lodash.filter(candidates, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x != target; }));
            //  Eliminate any batches that postdate the target (batches cannot fulfil earlier batches)
            candidates = lodash.filter(candidates, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.time <= target.time; }));
            //  Eliminates any candidates with zero balance
            //  TODO: optimise this using 'currentBalance' running variable
            candidates = lodash.filter(candidates, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.balanceAtTime(target.time) > 0; }));
            //  Filter out sources that do not match the target's sources property
            candidates = lodash.filter(candidates, (/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return _this.matchProperties(x, target); }));
            return candidates;
        };
        /**
         * @param {?} source
         * @param {?} target
         * @return {?}
         */
        Lineage.prototype.matchProperties = /**
         * @param {?} source
         * @param {?} target
         * @return {?}
         */
        function (source, target) {
            //  Test for properties
            /** @type {?} */
            var propertyMatched = true;
            lodash.forIn(target.criteria, (/**
             * @param {?} value
             * @param {?} key
             * @return {?}
             */
            function (value, key) {
                if (value != null) {
                    if (!(lodash.has(source.attributes, key) && source.attributes[key] == value)) {
                        propertyMatched = false;
                        return false;
                    }
                }
                else {
                    if (lodash.has(source.attributes, key) && source.attributes[key] != value) {
                        propertyMatched = false;
                        return false;
                    }
                }
            }));
            return propertyMatched;
        };
        /**
         * @param {?} batch
         * @return {?}
         */
        Lineage.prototype.remove = /**
         * @param {?} batch
         * @return {?}
         */
        function (batch) {
            lodash.remove(this.batches, batch);
        };
        return Lineage;
    }());
    if (false) {
        /** @type {?} */
        Lineage.prototype.batches;
        /** @type {?} */
        Lineage.prototype.flows;
        /** @type {?} */
        Lineage.prototype.add;
        /** @type {?} */
        Lineage.prototype.createFlow;
    }

    exports.Batch = Batch;
    exports.BatchType = BatchType;
    exports.Flow = Flow;
    exports.FlowMode = FlowMode;
    exports.Lineage = Lineage;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=seers-lineage.umd.js.map
