import { FlowMode } from './flow-mode';
import { BatchType } from './batch-type';
import { Flow } from './flow';
import { AdjustmentMode } from './adjustment-mode';
export interface Criteria {
    [key: string]: string;
}
export interface IBatch {
    id?: string;
    name?: string;
    time: Date;
    type: BatchType;
    criteria?: Criteria;
    quantity?: number;
    attributes?: {
        [key: string]: string;
    };
    measures?: {
        [key: string]: number;
    };
    flowMode?: FlowMode;
}
export declare class Batch {
    type: BatchType;
    constructor(batch?: any);
    id: string;
    name: string;
    private _time;
    time: Date;
    criteria: Criteria;
    quantity: number;
    attributes: {
        [key: string]: string;
    };
    measures: {
        [key: string]: number;
    };
    flowMode: FlowMode;
    adjustmentMode: AdjustmentMode;
    flowsIn: Flow[];
    flowsOut: Flow[];
    /** returns the balance of the batch */
    balanceAtTime: (time?: Date) => number;
    balancesOverTime: (times: Date[]) => number[];
    attributesAtTime: (time?: Date) => {
        [key: string]: string;
    };
    attributesOverTime: (times: Date[]) => {
        [key: string]: string;
    }[];
}
