import { Batch, IBatch } from './batch';
import { Flow } from './flow';
export declare class Lineage {
    batches: Batch[];
    flows: Flow[];
    add: (batch: IBatch) => Batch;
    process(): void;
    processAdjustment(adjustment: Batch): void;
    processAbsoluteAdjustment(adjustment: any): void;
    createFlowsProRata(sources: Batch[], target: Batch, totalFlowQuantity: number): void;
    processProRata(target: Batch, candidates: Batch[]): void;
    processLastInFirstOut(target: Batch, candidates: Batch[]): void;
    processFirstInFirstOut(target: Batch, candidates: Batch[]): void;
    createFlow: (source: Batch, target: Batch, time: Date, quantity: number) => void;
    /** returns a set of batches which could potentially fulfil a target batch */
    findCandidates(target: Batch): Batch[];
    matchProperties(source: Batch, target: Batch): boolean;
    remove(batch: Batch): void;
}
